<?php
/**
 * @package    vBulletin Payment Plugin
 * @author     Hamyar Programming Team
 * @copyright  2010-2014 Mohammad Hossein Abedinpour
 */
define('THIS_SCRIPT', 'hamyar_payment');
define('IS_ADMIN', true);
$phrasegroups = array();
$specialtemplates = array();
require_once ('./global.php');
require_once (DIR . '/hamyar_payment/class_hamyar_payment.php');
log_admin_action();
print_cp_header('فرم ساز پرداخت');
if (!can_administer('canadminads')) {
	print_cp_no_permission();
}
$payment = new hamyar_payment;
if (isset($_GET['do'])) {
	switch ($_GET['do']) {
		case 'setting' :
			exec_header_redirect('options.php?do=options&dogroup=hamyar_payment');
			exit ;
			break;
		case 'version' :
			print_form_header('hamyar_payment', 'version');
			print_table_header('بررسی کننده نسخه پلاگین');
			print_cells_row(array('<iframe src="http://hamyar.org/download/dl.php?do=vr&plugin=payment&old_vr=1.1"  frameborder="0"></iframe>'), false);
			print_cells_row(array('کلیه حقوق برای همیار محفوط است'), false);
			print_submit_row('بررسی دوباره', '');
			break;
		case 'delete' :
			$id = (int)$_REQUEST['id'];
			switch($_GET['mode']) {
				case 'form' :
					print_delete_confirmation('hamyar_payment_forms', $id, 'hamyar_payment', 'form_del', '', 0, '', 'form_name', 'form_id');
					break;
				case 'payment' :
					print_delete_confirmation('hamyar_payment_payments', $id, 'hamyar_payment', 'payment_del', '', 0, '', 'payment_id', 'payment_id');
					break;
			}
			break;
		case 'form_del' :
			$id = (int)$_REQUEST['form_id'];
			$vbulletin -> db -> query_write("DELETE FROM " . TABLE_PREFIX . "hamyar_payment_forms WHERE form_id='{$id}' ");
			$vbulletin -> db -> query_write("DELETE FROM " . TABLE_PREFIX . "hamyar_payment_payments WHERE payment_formid='{$id}' ");
			print_cp_redirect('hamyar_payment.php?do=forms');
			break;
		case 'payment_del' :
			$id = (int)$_REQUEST['payment_id'];
			@session_start();
			$vbulletin -> db -> query_write("DELETE FROM " . TABLE_PREFIX . "hamyar_payment_payments WHERE payment_id='{$id}' ");
			print_cp_redirect('hamyar_payment.php?do=' . $_SESSION['hamyar_payment_do']);
			break;
		case 'forms' :
			print_form_header('hamyar_payment', 'add_form', true);
			print_table_header('فرم ها', 6);
			print_cells_row(array(
				'ردیف',
				'نام',
				'سازنده',
				'تاریخ ساخت',
				'نوع فرم',
				'مدیریت'
			), 1);
			$name = $payment -> clean($_REQUEST['name']);
			if (!empty($name))
				$where = " WHERE form_name LIKE '%{$name}%'";
			$a = $vbulletin -> db -> query_first("SELECT count(form_id) FROM " . TABLE_PREFIX . "hamyar_payment_forms {$where}");
			$a = $a['count(form_id)'];
			$pages = new hamyar_payment_paginator;
			$pages -> items_total = $a;
			$pages -> paginate('forms&name=' . $name);
			$num = $pages -> low + 1;
			if ($a >= 1) {
				$a = $vbulletin -> db -> query("SELECT * FROM " . TABLE_PREFIX . "hamyar_payment_forms {$where} ORDER BY form_id DESC $pages->limit");
				$pages -> set_high();
				while ($value = $vbulletin -> db -> fetch_array($a)) {
					$manage = construct_link_code('ویرایش', "hamyar_payment.php?do=edit_form&id=" . $value['form_id']);
					$manage .= construct_link_code('حدف', "hamyar_payment.php?do=delete&mode=form&id=" . $value['form_id']);
					$manage .= construct_link_code('دریافت کد', "hamyar_payment.php?do=code_form&id=" . $value['form_id']);
					$manage .= construct_link_code('مشاهده پرداخت های این فرم', "hamyar_payment.php?do=payments&doform=1&form=" . $value['form_id']);
					$manage .= construct_link_code('مشاهده فرم', $vbulletin -> options['bburl'] . "/hamyar_payment.php?show=" . $value['form_id']);
					$type = ($value['form_type'] == 'pay') ? 'نمایش محتوا در ازای پرداخت' : 'فرم پرداخت Custom';
					print_cells_row(array(
						$num,
						$value['form_name'],
						$payment -> get_user_info($value['form_creator'], true),
						$payment -> get_date($value['form_createdate']),
						$type,
						$manage
					));
					$num++;
				}
				print_submit_row('اضافه کردن فرم تازه', '', 6);
				print_form_header('', '');
				print_table_header('صفحه بندی');
				print_label_row('اطلاعات', $pages -> show());
				print_label_row('تعداد نتایج در هر صفحه', $pages -> display_items_per_page());
				print_label_row('صفحه', $pages -> display_jump_menu());
				print_table_footer('');
				print_form_header('hamyar_payment', 'forms');
				print_table_header('جست و جو');
				print_input_row('نام فرم', 'name', $name);
				print_submit_row('جست و جو کن', '');
			} else {
				print_cells_row(array(
					'یافت نشد.',
					'یافت نشد.',
					'یافت نشد.',
					'یافت نشد.',
					'یافت نشد.',
					'یافت نشد.'
				));
				print_submit_row('اضافه کردن فرم تازه', '', 6);
			}

			break;
		case 'add_form' :
			if (!isset($_REQUEST['type']) || !in_array($_REQUEST['type'], array(
				'pay',
				'custom'
			))) {
				print_form_header('hamyar_payment', 'add_form');
				print_table_header('ساخت فرم جدید');
				print_select_row('نوع فرم را انتخاب کنید.', 'type', array(
					'custom' => 'فرم پرداخت Custom',
					'pay' => 'نمایش محتوا در ازای پرداخت'
				));
				print_submit_row('مرحله بعد', '');
			} else {
				if (isset($_REQUEST['doform'])) {
					if ($payment -> price_check($_REQUEST['price'])) {
						$name = $payment -> clean($_REQUEST['name']);
						if (empty($name)) {
							$payment -> error('لطفا نام فرم را وارد نمایید.');
						} else {
							$createdate = time();
							$creator = $vbulletin -> userinfo['userid'];
							$price = $_REQUEST['price'];
							switch($_REQUEST['type']) {
								case 'custom' :
									$des = $payment -> clean($_REQUEST['des']);
									$namef = (int)$_REQUEST['namef'];
									$emailf = (int)$_REQUEST['emailf'];
									$tellf = (int)$_REQUEST['tellf'];
									$guest = ($_REQUEST['guest']) ? 1 : 0;
									if ($price == 999999999)
										$price = '';
									$vbulletin -> db -> query_write("INSERT INTO " . TABLE_PREFIX . "hamyar_payment_forms 
									(form_type,form_price,form_des,form_name,form_creator,form_createdate,form_guest,form_namef,form_emailf,form_tellf) 
									VALUES 
									('custom','{$price}','{$des}','{$name}','{$creator}','{$createdate}','{$guest}','{$namef}','{$emailf}','{$tellf}');");
									break;
								case 'pay' :
									$hidetext = $payment -> clean($_REQUEST['hidetext'], true);
									$visibletext = $payment -> clean($_REQUEST['visibletext'], true);
									if (empty($hidetext) || empty($visibletext)) {
										$payment -> error('لطفا فیلد های اجباری را تکمیل نمایید.');
									} else {
										$vbulletin -> db -> query_write("INSERT INTO " . TABLE_PREFIX . "hamyar_payment_forms 
										(form_type,form_price,form_name,form_hidetext,form_visibletext,form_creator,form_createdate) 
										VALUES 
										('pay','{$price}','{$name}','{$hidetext}','{$visibletext}','{$creator}','{$createdate}');");
									}
									break;
							}
							print_cp_redirect('hamyar_payment.php?do=forms');
						}
					} else {
						$payment -> error($payment -> get_error());
					}
				} else {
					print_form_header('hamyar_payment', 'add_form');
					print_table_header('ساخت فرم جدید');
					print_input_row('نام فرم را وارد نمایید', 'name', '', true, 35, 255);
					switch($_REQUEST['type']) {
						case 'custom' :
							print_input_row('مبلغ فرم را به ' . $payment -> currency(true) . ' وارد فرمایید.<br/>در صورتی که می خواهید مبلغ فرم از کاربر دریافت شود عدد 999999999 را وارد کنید.', 'price');
							print_textarea_row('توضیحات پرداخت را وارد فرمایید.<br/>در صورت وارد نکردن توضیحات پرداخت از کاربر دریافت خواهد شد.', 'des');
							print_select_row('وضعیت دریافت نام کاربر', 'namef', array(
								'1' => 'نام دریافت شود و فیلد اجباری باشد.',
								'2' => 'نام دریافت شود اما فیلد اجباری نباشد.',
								'3' => 'نام دریافت نشود.',
							));
							print_select_row('وضعیت دریافت ایمیل کاربر', 'emailf', array(
								'1' => 'ایمیل دریافت شود و فیلد اجباری باشد.',
								'2' => 'ایمیل دریافت شود اما فیلد اجباری نباشد.',
								'3' => 'ایمیل دریافت نشود.',
							));
							print_select_row('وضعیت دریافت شماره همراه کاربر', 'tellf', array(
								'1' => 'شماره همراه دریافت شود و فیلد اجباری باشد.',
								'2' => 'شماره همراه دریافت شود اما فیلد اجباری نباشد.',
								'3' => 'شماره همراه دریافت نشود.',
							));
							print_yes_no_row('اجازه به کاربران مهمان جهت پرداخت با این فرم', 'guest');
							break;
						case 'pay' :
							print_input_row('مبلغ محصول را به ' . $payment -> currency(true) . ' وارد فرمایید.', 'price');
							print_textarea_row('محتوای پنهان که در صورت پرداخت به نمایش کاربر در می آید را وارد نمایید.<br/>استفاده از کد های HTML مجاز است.<br/>{price} : مبلغ فرم<br/>{username} : نام کاربر<br/>{currency} : واحد پول', 'visibletext');
							print_textarea_row('متنی که در صورت عدم پرداخت به نمایش کاربر در می آید را وارد نمایید.<br/>استفاده از کد های HTML مجاز است.<br/>{price} : مبلغ فرم<br/>{username} : نام کاربر<br/>{link} : لینک پرداخت<br/>{currency} : واحد پول', 'hidetext');
							break;
					}
					construct_hidden_code('type', $_REQUEST['type']);
					construct_hidden_code('doform', '1');
					print_submit_row('ساختن فرم', 'از نو');
				}
			}
			break;
		case 'code_form' :
			$id = (int)$_REQUEST['id'];
			$form = $payment -> get_form($id);
			if (!empty($form['form_id'])) {
				print_form_header('', '');
				print_table_header('کد های مربوط به فرم شماره ' . $id);
				print_textarea_row('BBCODE<br/>جهت استفاده از فرم پرداخت در پست های انجمن', 'bbcode', "[HAMYAR_PAYMENT=97%]{$id}[/hamyar_payment]");
				print_textarea_row('IFRAME<br/>جهت استفاده در خارج از انجمن و صفحات جدا', 'iframe', '<iframe src="' . $vbulletin -> options['bburl'] . '/hamyar_payment.php?hamyar_payment_form=' . $id . '" onload="this.style.height=this.contentWindow.document.body.scrollHeight+\'px\';this.style.display=\'inline\'" allowtransparency="yes" width="100%"  scrolling="no" frameborder="0"></iframe>');
				print_table_footer('');
			} else {
				$payment -> error('فرم مورد نظر یافت نشد');
			}
			break;
		case 'edit_form' :
			$id = (int)$_REQUEST['id'];
			$form = $payment -> get_form($id);
			if (!empty($form['form_id'])) {
				if (isset($_REQUEST['doform'])) {
					if ($payment -> price_check($_REQUEST['price'])) {
						$name = $payment -> clean($_REQUEST['name']);
						if (empty($name)) {
							$payment -> error('لطفا نام فرم را وارد نمایید.');
						} else {
							$price = $_REQUEST['price'];
							switch($form['form_type']) {
								case 'custom' :
									$des = $payment -> clean($_REQUEST['des']);
									$namef = (int)$_REQUEST['namef'];
									$emailf = (int)$_REQUEST['emailf'];
									$tellf = (int)$_REQUEST['tellf'];
									$guest = ($_REQUEST['guest']) ? 1 : 0;
									if ($price == 999999999)
										$price = '';
									$query = "UPDATE " . TABLE_PREFIX . "hamyar_payment_forms SET form_price='{$price}',form_des='{$des}',form_name='{$name}',form_guest={$guest},form_namef={$namef},form_emailf={$emailf},form_tellf={$tellf} WHERE form_id='{$id}'";
									$vbulletin -> db -> query($query);
									break;
								case 'pay' :
									$hidetext = $payment -> clean($_REQUEST['hidetext'], true);
									$visibletext = $payment -> clean($_REQUEST['visibletext'], true);
									if (empty($hidetext) || empty($visibletext)) {
										$payment -> error('لطفا فیلد های اجباری را تکمیل نمایید.');
									} else {
										$vbulletin -> db -> query_write("UPDATE " . TABLE_PREFIX . "hamyar_payment_forms SET form_price={$price},form_name='{$name}',form_hidetext='{$hidetext}',form_visibletext='{$visibletext}' WHERE form_id='{$id}'");
									}
									break;
							}
							print_cp_redirect('hamyar_payment.php?do=edit_form&id=' . $id);
						}
					} else {
						$payment -> error($payment -> get_error());
					}
				} else {
					print_form_header('hamyar_payment', 'edit_form');
					print_table_header('ویرایش فرم شماره ' . $id);
					print_input_row('نام فرم را وارد نمایید', 'name', $form['form_name'], true, 35, 255);
					switch($form['form_type']) {
						case 'custom' :
							if (empty($form['form_price']))
								$form['form_price'] = 999999999;
							print_input_row('مبلغ فرم را به ' . $payment -> currency(true) . ' وارد فرمایید.<br/>در صورتی که می خواهید مبلغ فرم از کاربر دریافت شود عدد 999999999 را وارد کنید.', 'price', $form['form_price']);
							print_textarea_row('توضیحات پرداخت را وارد فرمایید.<br/>در صورت وارد نکردن توضیحات پرداخت از کاربر دریافت خواهد شد.', 'des', $form['form_des']);
							print_select_row('وضعیت دریافت نام کاربر', 'namef', array(
								'1' => 'نام دریافت شود و فیلد اجباری باشد.',
								'2' => 'نام دریافت شود اما فیلد اجباری نباشد.',
								'3' => 'نام دریافت نشود.',
							), $form['form_namef']);
							print_select_row('وضعیت دریافت ایمیل کاربر', 'emailf', array(
								'1' => 'ایمیل دریافت شود و فیلد اجباری باشد.',
								'2' => 'ایمیل دریافت شود اما فیلد اجباری نباشد.',
								'3' => 'ایمیل دریافت نشود.',
							), $form['form_emailf']);
							print_select_row('وضعیت دریافت شماره همراه کاربر', 'tellf', array(
								'1' => 'شماره همراه دریافت شود و فیلد اجباری باشد.',
								'2' => 'شماره همراه دریافت شود اما فیلد اجباری نباشد.',
								'3' => 'شماره همراه دریافت نشود.',
							), $form['form_tellf']);
							print_yes_no_row('اجازه به کاربران مهمان جهت پرداخت با این فرم', 'guest', $form['form_guest']);
							break;
						case 'pay' :
							print_input_row('مبلغ محصول را به ' . $payment -> currency(true) . ' وارد فرمایید.', 'price', $form['form_price']);
							print_textarea_row('محتوای پنهان که در صورت پرداخت به نمایش کاربر در می آید را وارد نمایید.<br/>استفاده از کد های HTML مجاز است.<br/>متغیر های قابل استفاده:<br/>{price} : مبلغ فرم<br/>{username} : نام کاربر<br/>{currency} : واحد پول', 'visibletext', $form['form_visibletext']);
							print_textarea_row('متنی که در صورت عدم پرداخت به نمایش کاربر در می آید را وارد نمایید.<br/>استفاده از کد های HTML مجاز است.<br/>متغیر های قابل استفاده:<br/>{price} : مبلغ فرم<br/>{username} : نام کاربر<br/>{link} : لینک پرداخت<br/>{currency} : واحد پول', 'hidetext', $form['form_hidetext']);
							break;
					}
					construct_hidden_code('id', $id);
					construct_hidden_code('doform', '1');
					$type = ($form['form_type'] == 'pay') ? 'نمایش محتوا در ازای پرداخت' : 'فرم پرداخت Custom';
					print_label_row('نوع فرم', $type);
					print_label_row('سازنده', $payment -> get_user_info($form['form_creator'], true));
					print_label_row('تاریخ ساخت', $payment -> get_date($form['form_createdate']));
					print_label_row('حذف', construct_link_code('حدف', "hamyar_payment.php?do=delete&mode=form&id=" . $form['form_id']));
					print_submit_row('بروز رسانی فرم', 'از نو');
				}
			} else {
				$payment -> error('فرم مورد نظر یافت نشد.');
			}
			break;
		case 'payments' :
			if ($_REQUEST['doform']) {
				$where = ' WHERE payment_status=1';
				$do = 'payments';
				if (!empty($_REQUEST['username'])) {
					if (!($userinfo = $vbulletin -> db -> query_first("SELECT username, userid FROM " . TABLE_PREFIX . "user WHERE username = '" . $vbulletin -> db -> escape_string($_REQUEST['username']) . "'"))) {
						print_stop_message('invalid_user_specified');
					} else {
						$username = $userinfo['username'];
						$uid = $userinfo['userid'];
						$where .= " AND payment_userid='{$uid}'";
						$do .= "&username={$username}";
					}
				}
				if (!empty($_REQUEST['start']['year']) && !empty($_REQUEST['start']['day']) && !empty($_REQUEST['start']['month']) && !empty($_REQUEST['end']['year']) && !empty($_REQUEST['end']['day']) && !empty($_REQUEST['end']['month'])) {
					$start = $_REQUEST['start'];
					$end = $_REQUEST['end'];
					$start_time = mktime(0, 0, 0, $start['month'], $start['day'], $start['year']);
					$end_time = mktime(23, 59, 59, $end['month'], $end['day'], $end['year']);
					$where .= " AND payment_date >= $start_time AND payment_date <= $end_time ";
					$do .= '&start[year]=' . intval($_REQUEST['start']['year']) . '&start[month]=' . intval($_REQUEST['start']['month']) . '&start[day]=' . intval($_REQUEST['start']['day']);
					$do .= '&end[year]=' . intval($_REQUEST['end']['year']) . '&end[month]=' . intval($_REQUEST['end']['month']) . '&end[day]=' . intval($_REQUEST['end']['day']);
				}
				$form = (int)$_REQUEST['form'];
				$type = (int)$_REQUEST['type'];
				if (!in_array($type, array(
						1,
						2,
						3
					)))
					$type = 1;
				if ($form) {
					$where .= " AND payment_formid='{$form}'";
					$do .= '&form=' . $form;
				}
				$do .= '&type=' . $type;
				$do .= '&doform=1';
				$query = "SELECT count(payment_id) FROM " . TABLE_PREFIX . "hamyar_payment_payments {$where}";
				$a = $vbulletin -> db -> query_first($query);
				$a = $a['count(payment_id)'];
				$query = "SELECT sum(payment_price) FROM " . TABLE_PREFIX . "hamyar_payment_payments {$where}";
				$price = $vbulletin -> db -> query_first($query);
				$price = vb_number_format($payment -> final_price($price['sum(payment_price)']));
				if ($type == 1) {
					print_form_header('hamyar_payment', 'add_form', true);
					print_table_header('پرداخت ها', 7);
					print_cells_row(array(
						'ردیف',
						'مبلغ',
						'نام پرداخت کننده',
						'نام کاربری پرداخت کننده',
						'فرم پرداخت',
						'تاریخ',
						'مدیریت'
					), 1);
					$pages = new hamyar_payment_paginator;
					$pages -> items_total = $a;
					$pages -> paginate($do);
					@session_start();
					$_SESSION['hamyar_payment_do'] = $do;
					$num = $pages -> low + 1;
					if ($a >= 1) {
						$query = "SELECT * FROM " . TABLE_PREFIX . "hamyar_payment_payments ";
						$a = $vbulletin -> db -> query($query . " INNER JOIN " . TABLE_PREFIX . "hamyar_payment_forms ON payment_formid = form_id {$where}  ORDER BY payment_id DESC $pages->limit");
						$pages -> set_high();
						while ($value = $vbulletin -> db -> fetch_array($a)) {
							$value['payment_name'] = (empty($value['payment_name'])) ? 'وارد نشده' : $value['payment_name'];
							$formlink = "<a href='hamyar_payment.php?do=edit_form&id={$value['form_id']}'>{$value['form_name']}</a>";
							$manage = construct_link_code('مشاهده اطلاعات کامل', "hamyar_payment.php?do=show_payment&id=" . $value['payment_id']);
							$manage .= construct_link_code('حدف', "hamyar_payment.php?do=delete&mode=payment&id=" . $value['payment_id']);
							print_cells_row(array(
								$num,
								$payment -> get_show_price($value['payment_price']),
								$value['payment_name'],
								$payment -> get_user_info($value['payment_userid'], true),
								$formlink,
								$payment -> get_date($value['payment_date']),
								$manage
							));
							$num++;
						}
						print_table_footer('');
						print_form_header('', '');
						print_table_header('مجموع درآمد');
						print_label_row('جمع کل درآمد شما در این بازه', $price . ' ' . $payment -> currency(true));
						print_table_footer('');
						print_form_header('', '');
						print_table_header('صفحه بندی');
						print_label_row('اطلاعات', $pages -> show());
						print_label_row('تعداد نتایج در هر صفحه', $pages -> display_items_per_page());
						print_label_row('صفحه', $pages -> display_jump_menu());
						print_table_footer('');
					} else {
						print_cells_row(array(
							'یافت نشد.',
							'یافت نشد.',
							'یافت نشد.',
							'یافت نشد.',
							'یافت نشد.',
							'یافت نشد.',
							'یافت نشد.'
						));
						print_table_footer('');
					}
				} else {
					print_form_header('', '');
					$title = ($type == 2) ? 'یوزرنیم ها' : 'ایمیل ها';
					print_table_header($title);
					if ($type == 2) {
						$a = $vbulletin -> db -> query("SELECT payment_userid FROM " . TABLE_PREFIX . "hamyar_payment_payments WHERE payment_userid!='0' AND payment_userid!='' AND payment_status=1");
						$ids = array();
						while ($value = $vbulletin -> db -> fetch_array($a)) {
							if (!in_array($value['payment_userid'], $ids) && !empty($value['payment_userid']) && $value['payment_userid'] != 0)
								$ids[] = $value['payment_userid'];
						}
						$ids = implode(',', $ids);
						$query = "SELECT username,userid FROM " . TABLE_PREFIX . "user WHERE userid IN ({$ids})";
						$a = $vbulletin -> db -> query($query);
						$eusername = array();
						while ($value = $vbulletin -> db -> fetch_array($a)) {
							if (!in_array($value['username'], $eusername))
								$eusername[] = $value['username'];
						}
						$data = implode(';', $eusername);
					} else {
						$a = $vbulletin -> db -> query("SELECT payment_userid,payment_email FROM " . TABLE_PREFIX . "hamyar_payment_payments WHERE ((payment_userid!='' AND payment_userid!='0') OR payment_email!='') AND payment_status=1");
						$ids = array();
						$email = array();
						while ($value = $vbulletin -> db -> fetch_array($a)) {
							if (!empty($value['payment_email'])) {
								if (!in_array($value['payment_email'], $email))
									$email[] = $value['payment_email'];
							} else {
								if (!in_array($value['payment_userid'], $ids) && !empty($value['payment_userid']) && $value['payment_userid'] != 0)
									$ids[] = $value['payment_userid'];
							}
						}
						if (sizeof($ids)) {
							$ids = implode(',', $ids);
							$query = "SELECT email,userid FROM " . TABLE_PREFIX . "user WHERE userid IN ({$ids})";
							$a = $vbulletin -> db -> query($query);
							while ($value = $vbulletin -> db -> fetch_array($a)) {
								if (!in_array($value['email'], $email))
									$email[] = $value['email'];
							}
						}
						$data = implode(',', $email);
					}
					print_textarea_row('', 'des', $data, 10, 100);
					print_table_footer('');
				}
			}
			print_form_header('hamyar_payment', 'payments');
			print_table_header('فیلتر کردن تراکنش ها');
			print_label_row('بااستفاده از این قسمت می توانید تراکنش های مورد نظر خود را پیدا کنید و از اطلاعات آن ها خروجی بگیرید.');
			print_input_row('یوزرنیم را وارد کنید.<br/>در صورت وارد نکردن تراکنش تمام کاربران جست و جو خواهد شد.', 'username', $username);
			print_time_row($vbphrase['start_date'], 'start', $start, false);
			print_time_row($vbphrase['end_date'], 'end', $end, false);
			$f = array();
			$f[0] = '- - - -';
			$a = $vbulletin -> db -> query("SELECT * FROM " . TABLE_PREFIX . "hamyar_payment_forms");
			while ($value = $vbulletin -> db -> fetch_array($a)) {
				$f[$value['form_id']] = $value['form_name'] . ' - ' . $value['form_id'];
			}
			print_select_row('فرم پرداخت', 'form', $f, $form);
			print_select_row('نوع خروجی', 'type', array(
				'1' => 'اطلاعات کامل',
				'2' => 'یوزرنیم ها',
				'3' => 'ایمیل ها',
			), $type);
			construct_hidden_code('doform', '1');
			print_submit_row('فیلتر کن', '');
			break;
		case 'show_payment' :
			$id = (int)$_REQUEST['id'];
			$paymentd = $payment -> get_payment($id);
			if ($paymentd['payment_id']) {
				if ($paymentd['payment_status'] == 1) {
					print_form_header('', '');
					$title = 'جزئییات تراکنش شماره ' . $id;
					print_table_header($title);
					print_label_row('شماره تراکنش', $id);
					$name = (empty($paymentd['payment_name'])) ? 'وارد نشده' : $paymentd['payment_name'];
					print_label_row('نام انجام دهنده تراکنش', $name);
					print_label_row('نام کاربری انجام دهنده تراکنش', $payment -> get_user_info($paymentd['payment_userid'], true));
					$tell = (empty($paymentd['payment_tell'])) ? 'وارد نشده' : $paymentd['payment_tell'];
					print_label_row('شماره تماس انجام دهنده تراکنش', $tell);
					if (!empty($paymentd['payment_email']))
						$email = $paymentd['payment_email'];
					else {
						if (!empty($paymentd['payment_userid'])) {
							$data = $payment -> get_user_info($paymentd['payment_userid']);
							$email = $data['email'];
						}
					}
					if (!$email)
						$email = 'وارد نشده';
					print_label_row('ایمیل انجام دهنده تراکنش', $email);
					print_label_row('مبلغ تراکنش', $payment -> get_show_price($paymentd['payment_price']));
					print_label_row('آیپی انجام دهنده تراکنش', $paymentd['payment_ip']);
					print_label_row('درگاه انجام دهنده تراکنش', $paymentd['payment_gateway']);
					print_label_row('درگاه انجام دهنده تراکنش', $payment -> get_date($paymentd['payment_date']));
					print_label_row('وضعیت پرداخت تراکتش', 'پرداخت شده');
					print_label_row('شماره فاکتور تراکنش', $paymentd['payment_orderid']);
					print_label_row('REFID', $paymentd['payment_refid']);
					print_label_row('RECID', $paymentd['payment_recid']);
					$value = $payment -> get_form($paymentd['payment_formid']);
					$formlink = "<a href='hamyar_payment.php?do=edit_form&id={$value['form_id']}'>{$value['form_name']}</a>";
					print_label_row('فرم پرداخت', $formlink);
					print_label_row('توضیحات', $payment -> nl2br($paymentd['payment_des']));
					print_label_row('حذف', construct_link_code('حدف', "hamyar_payment.php?do=delete&mode=payment&id=" . $id));
					print_table_footer('');
					@session_start();
					echo '<br/><div align="center">' . construct_link_code('بازگشت', "hamyar_payment.php?do=" . $_SESSION['hamyar_payment_do']) . '</div>';
				} else {
					$payment -> error('تراکنش مورد نظر تمام نشده است.');
				}
			} else {
				$payment -> error('تراکنش مورد نظر یافت نشد');
			}
			break;
		case 'add' :
			if (isset($_REQUEST['doform'])) {
				if (!empty($_REQUEST['username'])) {
					if (!($userinfo = $vbulletin -> db -> query_first("SELECT username, userid FROM " . TABLE_PREFIX . "user WHERE username = '" . $vbulletin -> db -> escape_string($_REQUEST['username']) . "'"))) {
						print_stop_message('invalid_user_specified');
					} else {
						$username = $userinfo['username'];
						$uid = $userinfo['userid'];
						$form = $payment -> get_form($_REQUEST['form']);
						if ($form['form_id']) {
							$form = $form['form_id'];
							if (!$payment -> check_payment($form, $uid)) {
								$date = time();
								$userip = $_SERVER['REMOTE_ADDR'];
								$vbulletin -> db -> query_write("INSERT INTO `" . TABLE_PREFIX . "hamyar_payment_payments`
							(`payment_formid`, `payment_userid`, `payment_status`, `payment_refid`, `payment_orderid`, `payment_gateway`, `payment_date`, `payment_ip`, `payment_price`, `payment_des`, `payment_name`, `payment_email`, `payment_tell`)
							VALUES
							('{$form}', '{$uid}', 1, 1, 1, 'admin', '{$date}', '{$userip}', '0', '', '', '', '');");
								print_cp_redirect('hamyar_payment.php?do=add');
							} else {
								$payment -> error('این کاربر قبلا این فرم را پرداخت کرده است.');
							}
						} else {
							$payment -> error('فرم انتخاب شده معتبر نیست.');
						}
					}
				} else {
					$payment -> error('یوزرنیم را وارد نمایید.');
				}
			}
			print_form_header('hamyar_payment', 'add');
			print_table_header('اضافه کردن سفارش');
			$a = $vbulletin -> db -> query("SELECT form_type,form_id,form_name FROM " . TABLE_PREFIX . "hamyar_payment_forms WHERE form_type='pay' ");
			while ($b = $vbulletin -> db -> fetch_array($a))
				$forms[$b['form_id']] = $b['form_name'];
			print_select_row('فرم را انتخاب فرمایید.', 'form', $forms, $form);
			print_input_row('یوزرنیم را وارد نمایید.', 'username', $username);
			construct_hidden_code('doform', '1');
			print_submit_row('اضافه کردن', 'از نو');
			break;
		default :
			$payment -> error('درخواست مورد نظر یافت نشد.');
			break;
	}
} else {
	$payment -> error('درخواست مورد نظر یافت نشد.');
}
print_cp_footer();
?>