<?php
/**
 * @package    vBulletin Payment Plugin
 * @author     Hamyar Programming Team
 * @copyright  2010-2014 Mohammad Hossein Abedinpour
 */
error_reporting(0);
define('THIS_SCRIPT', 'hamyar_donate');
define('CSRF_PROTECTION', false);
$phrasegroups = array();
$specialtemplates = array();
$globaltemplates = array('hamyar_payment');
$actiontemplates = array();
require_once ('./global.php');
include DIR . '/hamyar_payment/class_hamyar_payment.php';
$hamyar_payment = new hamyar_payment;
//do payment
if (isset($_REQUEST['payment'])) {
	$form = $hamyar_payment -> get_form($_REQUEST['payment']);
	if ($form['form_id']) {
		$userid = $vbulletin -> userinfo['userid'];
		$userip = $_SERVER['REMOTE_ADDR'];
		$formid = $form['form_id'];
		$date = time();
		switch($form['form_type']) {
			case 'custom' :
				if (!$vbulletin -> userinfo['userid'] && !$form['form_guest']) {
					print_no_permission();
					exit ;
				}
				//Check User E-mail
				if ($form['form_emailf'] != 3 && !$vbulletin -> userinfo['userid']) {
					if ($form['form_emailf'] == 1 && !preg_match('/[A-Za-z0-9_-]+\@[A-Za-z0-9_-]+\.[A-Za-z0-9_-]+/', $_REQUEST['email']))
						die(json_encode(array(
							'error',
							'لطفا ایمیل خود را به صورت صحیح وارد کنید.'
						)));
					if (!empty($_REQUEST['email']) && $form['form_emailf'] == 2 && !preg_match('/[A-Za-z0-9_-]+\@[A-Za-z0-9_-]+\.[A-Za-z0-9_-]+/', $_REQUEST['email']))
						die(json_encode(array(
							'error',
							'لطفا ایمیل خود را به صورت صحیح وارد کنید.'
						)));
					$email = $hamyar_payment -> clean($_REQUEST['email']);
				} else
					$email = '';
				//Check User Mobile
				if ($form['form_tellf'] != 3) {
					if ($form['form_tellf'] == 1 && !eregi('^09([0-9]{9})$', $_REQUEST['tell']))
						die(json_encode(array(
							'error',
							'لطفا شماره همراه خود را به صورت صحیح وارد کنید.'
						)));
					if (!empty($_REQUEST['tell']) && $form['form_tellf'] == 2 && !eregi("^09([0-9]{9})$", $_REQUEST['tell']))
						die(json_encode(array(
							'error',
							'لطفا شماره همراه خود را به صورت صحیح وارد کنید.'
						)));
					$tell = $hamyar_payment -> clean($_REQUEST['tell']);
				} else
					$tell = '';
				//Check User Name
				if ($form['form_namef'] != 3) {
					if ($form['form_namef'] == 1 && empty($_REQUEST['name']))
						die(json_encode(array(
							'error',
							'لطفا نام خود را به صورت صحیح وارد کنید.'
						)));
					$name = $hamyar_payment -> clean($_REQUEST['name']);
				} else
					$name = '';
				//Price
				if (empty($form['form_price'])) {
					if ($hamyar_payment -> price_check(str_replace(',', '', $_REQUEST['price'])))
						$price = $hamyar_payment -> clean($hamyar_payment -> final_price(str_replace(',', '', $_REQUEST['price'])));
					else
						die(json_encode(array(
							'error',
							$hamyar_payment -> get_error()
						)));
				} else
					$price = $hamyar_payment -> final_price($form['form_price']);

				//Des
				$des = (empty($form['form_des'])) ? $hamyar_payment -> clean($_REQUEST['des']) : $hamyar_payment -> clean($form['form_des']);
				//Connect
				$hamyar_payment -> connect($formid, $userid, $date, $userip, $price, $des, $name, $email, $tell);
				break;
			case 'pay' :
				if ($vbulletin -> userinfo['userid']) {
					if ($hamyar_payment -> check_payment($form['form_id'], $vbulletin -> userinfo['userid'])) {
						$hamyar_payment -> error('شما قبلا این فرم را پرداخت کرده اید.');
						exit ;
					} else {
						//Toman
						$price = $hamyar_payment -> final_price($form['form_price']);
						//Connect
						define('SHOW_HTML', true);
						$hamyar_payment -> connect($formid, $userid, $date, $userip, $price);
					}
				} else {
					print_no_permission();
				}
				break;
		}
	}
	exit ;
}
//show iframe
if (isset($_GET['hamyar_payment_form'])) {
	$form = $hamyar_payment -> get_form($_GET['hamyar_payment_form']);
	if ($form['form_id']) {
		$width = (isset($_GET['bbcode'])) ? '100%' : '700px';
		$width = (isset($_GET['width'])) ? $hamyar_payment -> clean($width) : $width;
		echo '<!DOCTYPE html><html xmlns="http://www.w3.org/1999/xhtml" dir="rtl" lang="fa-IR"><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="generator" content="@hamyar" /><link rel="stylesheet" href="' . $vbulletin -> options['bburl'] . '/hamyar_payment/style.css" type="text/css"/><script src="' . $vbulletin -> options['bburl'] . '/hamyar_payment/js/jquery-1.9.1.min.js"></script><script src="' . $vbulletin -> options['bburl'] . '/hamyar_payment/js/main.js"></script></head><body>';
		echo '<script>window.hamyar_error="' . $hamyar_payment -> get_error() . '"</script>';
		switch($form['form_type']) {
			case 'custom' :
				if ($form['form_guest'] == 0 && !$vbulletin -> userinfo['userid']) {
					echo '<div class="hamyar_payment" style="width:' . $width . '">';
					$regs = true;
				} else {
					echo '<div class="hamyar_payment" style="width:700px">';
					echo '<form id="payment" method="post" action="">';
					if ($form['form_namef'] != 3) {
						if ($form['form_namef'] == 1)
							$req = 'required';
						echo '<input type="name" class="hamyar_payment_textbox" id="hamyar_payment_name" name="name" placeholder="نام و نام خانوادگی" ' . $req . '>';
					}
					if ($form['form_emailf'] != 3) {
						if ($form['form_emailf'] == 1)
							$req = 'required';
						if ($vbulletin -> userinfo['email'])
							$value = "value='{$vbulletin -> userinfo['email']}' readonly";
						echo '<input type="email" class="hamyar_payment_textbox" name="email" id="hamyar_payment_email" ' . $value . ' placeholder="پست الکترونیکی" ' . $req . '>';
					}
					if ($form['form_tellf'] != 3) {
						if ($form['form_tellf'] == 1)
							$req = 'required';
						echo '<input type="text" class="hamyar_payment_textbox" name="tell" pattern="^09([0-9]{9})$" id="hamyar_payment_phone" placeholder="شماره تماس" ' . $req . '>';
					}
					$min = ($hamyar_payment -> currency() == 1) ? 1000 : 100;
					if (empty($form['form_price'])) {
						echo '<input type="text" min="' . $min . '" name="price" class="hamyar_payment_textbox" id="hamyar_payment_amount" placeholder="مبلغ ( ' . $hamyar_payment -> currency(true) . ' )" required>';
					} else
						echo '<input type="text" class="hamyar_payment_textbox" value="' . vb_number_format($form['form_price']) . ' ' . $hamyar_payment -> currency(true) . '" readonly id="hamyar_payment_amount">';
					if (empty($form['form_des'])) {
						echo '<textarea class="hamyar_payment_textarea" name="des" placeholder="توضیحات"></textarea>';
					} else
						echo '<textarea class="hamyar_payment_textarea" readonly placeholder="توضیحات">' . $form['form_des'] . '</textarea>';

					echo '<input class="hamyar_payment_submit" id="pay" type="submit" value="ارسال مبلغ"><input type="hidden" name="payment" value="' . $form['form_id'] . '" /><i class="hamyar_payment_submit_icon"></i><form>';
				}
				break;
			case 'pay' :
				@session_start();
				$_SESSION['hamyar_payment_' . $form['form_id']] = $_SERVER['HTTP_REFERER'];
				echo '<div class="hamyar_payment" style="width:' . $width . '">';
				if (!$vbulletin -> userinfo['userid'])
					$regs2 = vb_number_format($form['form_price']);
				elseif (!$hamyar_payment -> check_payment($form['form_id'], $vbulletin -> userinfo['userid'])) {
					$link = $vbulletin -> options['bburl'] . '/hamyar_payment.php?payment=' . $form['form_id'];
					$message = str_replace(array(
						'{price}',
						'{link}',
						'{username}',
						'{currency}'
					), array(
						vb_number_format($form['form_price']),
						$link,
						$vbulletin -> userinfo['username'],
						$hamyar_payment -> currency(true)
					), $form['form_hidetext']);
					echo '<div class="hamyar_payment_error_message"><div class="hamyar_payment_error_icon"></div>' . $message . '</div>';
				} else {
					$message = str_replace(array(
						'{price}',
						'{username}',
						'{currency}'
					), array(
						vb_number_format($form['form_price']),
						$vbulletin -> userinfo['username'],
						$hamyar_payment -> currency(true)
					), $form['form_visibletext']);
					echo '<div class="hamyar_payment_success_message"><div class="hamyar_payment_success_icon"></div>' . $message . '</div>';
				}
				break;
		}
		if ($regs)
			echo '<div class="hamyar_payment_error_message"><div class="hamyar_payment_error_icon"></div>لطفا برای مشاهده این فرم پرداخت در سایت <a href="' . $vbulletin -> options['bburl'] . '">وارد</a> شوید یا <a href="' . $vbulletin -> options['bburl'] . '/register.php">ثبت نام</a> نمایید.</div>';
		if ($regs2)
			echo '<div class="hamyar_payment_error_message"><div class="hamyar_payment_error_icon"></div>شما برای مشاهده این قسمت از محتوا نیاز به پرداخت مبلغ ' . $regs2 . ' ' . $hamyar_payment -> currency(true) . ' دارید، لطفا برای پرداخت <a href="' . $vbulletin -> options['bburl'] . '">وارد</a> شوید یا <a href="' . $vbulletin -> options['bburl'] . '/register.php">ثبت نام</a> نمایید.</div>';

		echo '</div></body></html>';
		exit ;
	}
	exit ;
}
//show payment form
if (isset($_GET['show'])) {
	$form = $hamyar_payment -> get_form($_GET['show']);
	if ($form['form_id']) {
		$templater = vB_Template::create('hamyar_payment');
		$navbits = construct_navbits(array('' => $form['form_name']));
		$navbar = render_navbar_template($navbits);
		$templater -> register_page_templates();
		$templater -> register('navbar', $navbar);
		$templater -> register('help', $vbulletin -> options['hamyar_upc_help']);
		$templater -> register('pagetitle', $form['form_name']);
		$templater -> register('formid', $form['form_id']);
		print_output($templater -> render());
	}
	exit ;
}
//callback
if (isset($_REQUEST['callback'])) {
	$payment = $hamyar_payment -> get_payment($_REQUEST['callback']);
	if ($payment['payment_id']) {
		if ($payment['payment_userid'] != '') {
			if ($payment['payment_userid'] != $vbulletin -> userinfo['userid']) {
				$hamyar_payment -> error('این تراکنش مربوط به شما نیست.');
				exit ;
			}
		}
		if ($payment['payment_status'] != 0) {
			$hamyar_payment -> error('این تراکنش قبلا تمام شده است.');
		} else {
			$class = 'hamyar_payment_' . $payment['payment_gateway'];
			if (!class_exists($class))
				$hamyar_payment -> error('Invalid Gateway');
			if (!class_exists('nusoap_client'))
				require_once (DIR . "/hamyar_payment/lib/nusoap.php");
			$gatewayobj = new $class;
			$refid = $gatewayobj -> get_refid(array());
			$paymentid = $payment['payment_id'];
			$data = $gatewayobj -> callback($payment['payment_recid'], $payment['payment_orderid'], $refid, $payment['payment_price']);
			//For some webservices like SibaPal
			$refid = $gatewayobj -> get_refid($data);
			if ($data['status'] == 1) {
				$return = 'پرداخت با موفقیت انجام شد، با تشکر از شما';
				@session_start();
				if ($_SESSION['hamyar_payment_' . $payment['payment_formid']]) {
					$link = $hamyar_payment -> clean($_SESSION['hamyar_payment_' . $payment['payment_formid']]);
					$return .= "<br/><a href='{$link}'>مشاهده محتوای مخفی</a>";
					unset($_SESSION['hamyar_payment_' . $payment['payment_formid']]);
				}
				//Send E-mails
				$bbtitle = $vbulletin -> options['bbtitle'];
				$bbtitle = html_entity_decode($bbtitle, ENT_QUOTES, "UTF-8");
				$date = $hamyar_payment -> get_date($payment['payment_date']);
				$url = $vbulletin -> options['bburl'];
				$sig = "<br/>با تشکر / {$bbtitle}<br/>{$url}";
				$link = $url . '/' . $vbulletin -> config['Misc']['admincpdir'] . '/hamyar_payment.php?do=show_payment&id=' . $paymentid;
				$headers = "Content-type: text/html\r\n";
				$from = $vbulletin -> options['webmasteremail'];
				$price = $hamyar_payment -> get_show_price($payment['payment_price']);
				//Admin E-mail
				if (!empty($vbulletin -> options['hamyar_payment_adminemail'])) {
					$title = "تراکنش شماره {$paymentid} در سایت {$bbtitle} انجام شد.";
					$body = "تراکنش شماره {$paymentid} در سایت {$bbtitle} انجام شد.<br/>مبلغ تراکنش: {$price}<br/>تاریخ انجام: {$date}<br/><a href='{$link}'>اطلاعات بیشتر</a>{$sig}";
					vbmail($vbulletin -> options['hamyar_payment_adminemail'], $title, $body, true, $from, $headers);
				}
				//User E-mail
				if ($vbulletin -> options['hamyar_payment_useremail']) {
					if (!empty($payment['payment_email']))
						$email = $payment['payment_email'];
					else {
						if (!empty($payment['payment_userid'])) {
							$data = $hamyar_payment -> get_user_info($payment['payment_userid']);
							$email = $data['email'];
						}
						if ($email) {
							$title = "تراکنش شماره {$paymentid} شما در سایت {$bbtitle} انجام شد.";
							$body = "با سلام<br/>" . "تراکنش شماره {$paymentid} شما در سایت {$bbtitle} با موفقیت انجام شد.<br/>مبلغ تراکنش: {$price}<br/>تاریخ انجام: {$date}{$sig}";
							vbmail($email, $title, $body, true, $from, $headers);
						}
					}
				}
				$vbulletin -> db -> query("UPDATE `" . TABLE_PREFIX . "hamyar_payment_payments` SET payment_status = '1', payment_refid='{$refid}' WHERE payment_id = '{$paymentid}'");
			} else {
				$return = $data['message'];
				$vbulletin -> db -> query("UPDATE `" . TABLE_PREFIX . "hamyar_payment_payments` SET payment_status = '2', payment_refid='{$refid}' WHERE payment_id = '{$paymentid}'");
			}
			$return .= $gatewayobj -> get_codes($payment['payment_orderid'], $refid);
			$return .= '<br/>حتما کد های رهگیری را یادداشت فرمایید در صورت عدم یادداشت امکان رهگیری پرداخت در صورت بروز مشکل وجود ندارد.';
			$hamyar_payment -> error($return);
		}
	}
}
